<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use App\State;
use App\StateAprobacion;
use App\Persona;
use App\Usuarios;
use App\Especialidad;
use App\Sede;
use App\TipoEspecialidad;
use App\TipoSede;
use App\PersonAseguradora;
use App\Aseguradora;
use App\Reportes;

class MedicoController extends Controller
{
    // Vista Principal
    //--------------------------------------------------------------------------------------------------------------
    public function index(){
        return view('medico.index');
    }
    //-------------------------------------------------------------------------------------------------------
    public function createReports(Request $request){
        if(isset($_FILES["archivo"]["name"]))
        {
                $file_names = $_FILES["archivo"]["name"];
                $original_file_name = pathinfo($file_names, PATHINFO_FILENAME);
                $file_type = explode(".", $file_names); $extension = end($file_type);
                if($extension == "docx"){
                    $url_file = "../public/filePaciente/word/".$original_file_name.".".$extension;
                    $urlFile = "/filePaciente/word/".$original_file_name.".".$extension;
                }else if($extension=="pdf"){
                    $url_file = "../public/filePaciente/pdf/".$original_file_name.".".$extension;
                    $urlFile = "/filePaciente/pdf/".$original_file_name.".".$extension;
                }
                    try{
                        DB::beginTransaction();
                            $reports = new Reportes();
                            $reports->id_paciente = $request->paciente;
                            $reports->codigo = date('YmdGi');
                            $reports->id_person_upload = $request->session()->get('id_persona');
                            $reports->id_person_atendido = $request->medico;
                            $reports->nombre_file = $original_file_name;
                            $reports->url_file = $urlFile;
                            $reports->extension = ".".$extension;
                            $reports->estado_view = 1;
                            $reports->state = 1;
                            $reports->save();
                            $bool = true;
                        DB::commit();
                    } catch(Exception $e){
                        $bool = false;
                        $error = $e;
                        DB::rollback();
                    }
                move_uploaded_file($_FILES["archivo"]["tmp_name"], $url_file);
            return ['save'=>$bool];
        }
    }
    //----------------------------------------------------------------------------------------------------------------
    public function ListReportes(Request $request){
        $dataReports = Reportes::join('personas as p1','reportes.id_paciente','=','p1.id')
        ->join('personas as p2','reportes.id_person_upload','=','p2.id')
        ->join('personas as p3','reportes.id_person_atendido','=','p3.id')
        ->join('state_aprobacion','reportes.estado_view','=','state_aprobacion.id')
        ->where('reportes.state','=',1)
        ->where('reportes.id_person_atendido','=',$request->session()->get('id_persona'))
        ->select('reportes.created_at as fecha','reportes.id',
        'reportes.codigo','p1.nombres','p1.apellidos',
        'p2.nombres as nombreupload','reportes.url_file','reportes.nombre_file',
        'reportes.extension','state_aprobacion.nombre as estado',
        'reportes.state','p3.nombres as atendido')
        ->get();
        return ['reportes'=>$dataReports];
    }
    //----------------------------------------------------------------------------------------------------------------
    public function deleteReporte(Request $request){
        $delete = Reportes::where('id','=',$request->id_reporte)->get();
        $delete[0]->state = 2;
        $delete[0]->save();
        return ['usuario'=>true];
    }
    //-----------------------------------------------------------------------------------------------------------
    public function ListMedicos(Request $request){
        $medic = Usuarios::join('personas','users.id_user','=','personas.id')
        ->join('person_sede','users.id_user','=','person_sede.id_persona')
        ->join('person_especialidad','users.id_user','=','person_especialidad.id_persona')
        ->where('users.idrol','=',2)
        ->where('users.estado_registro','=',1)
        ->where('personas.id','=',$request->session()->get('id_persona'))
        ->select('users.id_user','users.email','users.estado_registro as state'
        ,'personas.nombres','personas.apellidos',
        'personas.telefono','personas.correo','personas.direccion',
        'person_especialidad.id_especialidad as especialidad',
        'person_sede.id_sede as sede')
        ->get();
        return['medicos'=>$medic];
    }
    //-----------------------------------------------------------------------------------------------------------------------
    public function searchPaciente(Request $request){
        $persona = Persona::join('users as u','personas.id','=','u.id_user')
        ->where('personas.identificacion','=',$request->cedula)
        ->where('u.estado_registro','=',1)
        ->select('personas.*')->get();
        return ['pacientes'=>$persona];
    }
    // ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    public function listAseguradora(){
        $data = Aseguradora::where('id','<>',3)->select('*')->get();
        return ['aseguradora'=>$data];
    }
     // ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
     public function crearpaciente(Request $request){
        if (!$request->ajax()) return redirect('/');
        $dataProfesions = '';
            try {
                DB::beginTransaction();
                // guadar persona
                $data = $request;
                $persona = new Persona();
                $persona->identificacion = $request->ndoc;
                $persona->tipoidentificacion = $request->tipodoc;
                $persona->nombres = $request->nombres;
                $persona->apellidos = $request->apellidos;
                $persona->telefono = $request->telefono;
                $persona->correo = $request->correo;
                $persona->entidad = $request->entidad;
                $persona->estado_registro = 1;
                $persona->save();
                // guardar usuario
                $user = new Usuarios();
                $user->id_user = $persona->id;
                $user->email = $request->usuario;
                $user->password = bcrypt($request->password);
                $user->generica = $request->generica;
                $user->estado_registro = 1;
                $user->idrol = $request->rol;
                $user->id_user_create=$request->session()->get('id_persona');
                $user->save();
                $guardo = true;
                DB::commit();
            } catch (\Throwable $th) {
                $guardo=false;
                DB::rollback();
            }
            // mensaje 
            return ['save'=>$guardo];
    }
     // verificar los usuarios que se crean 
    //-------------------------------------------------------------------------------------------------------------------

    public function checkuser(Request $request){
        $data = Usuarios::where('email','=',$request->user)->get();
        if(sizeof($data)>0){
            return ['dataResult'=> true];
        }
        return ['dataResult'=> false];
    }
    
   
    // ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    public function saveAseguradora(Request $request){
        if (!$request->ajax()) return redirect('/');
        $especi = new Aseguradora();
        $especi->nombre = $request->aseguradora;
        $especi->nit = $request->nit;
        $especi->state = 1;
        $especi->save();
        return ['save'=>true];
    }
    //---------------------------------------------------------------------------------------------------------------------------
    public function saveEditReporte(Request $request){
        if (!$request->ajax()) return redirect('/');
        $reports = Reportes::where('id','=', $request->id_reporte)->get();
        $file_names=""; $original_file_name=""; $extension=""; $url_file="";$boolFile =false;
        $urlFile="";
        if(isset($_FILES["archivo"]["name"]))
        {
                $file_names = $_FILES["archivo"]["name"];
                $original_file_name = pathinfo($file_names, PATHINFO_FILENAME);
                $file_type = explode(".", $file_names); $extension = end($file_type);
                if($extension == "docx"){
                    $url_file = "../public/filePaciente/word/".$original_file_name.".".$extension;
                    $urlFile = "/filePaciente/word/".$original_file_name.".".$extension;
                }else if($extension=="pdf"){
                    $url_file = "../public/filePaciente/pdf/".$original_file_name.".".$extension;
                    $urlFile = "/filePaciente/pdf/".$original_file_name.".".$extension;
                }
                move_uploaded_file($_FILES["archivo"]["tmp_name"], $url_file);
                $boolFile = true;
        }
        try{
            DB::beginTransaction();
                $reports[0]->id_paciente = $request->paciente;
                $reports[0]->id_person_atendido = $request->medico;
                if($boolFile)
                {
                    $reports[0]->nombre_file = $original_file_name;
                    $reports[0]->url_file = $urlFile;
                    $reports[0]->extension = ".".$extension;
                }
                $reports[0]->save();
                $bool = true;
            DB::commit();
        } catch(Exception $e){
            $bool = false;
            $error = $e;
            DB::rollback();
        }
       return ['save'=>$bool];

    }
    
}